<?php

namespace App\Controller;

use App\Request\DetailRequest;
use App\Request\RestaurantListingRequest;
use App\Service\RestaurantDetailService;
use App\Service\RestaurantListingService;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController as BundleController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Attribute\Route;

#[Route('/api/v1/restaurants')]
class RestaurantsController extends BundleController
{
    public function __construct(
        private readonly RestaurantListingService $listingService,
        private readonly RestaurantDetailService $detailService,
    ) {}

    #[Route('/', name: 'restaurants', methods: ['GET'])]
    public function restaurants(RestaurantListingRequest $request): JsonResponse
    {
        return (new Handle($this->listingService))->handle($request);
    }

    #[Route('/{detailId}', name: 'restaurant', methods: ['GET'])]
    public function restaurant(DetailRequest $request): JsonResponse
    {
        return (new Handle($this->detailService))->handle($request);
    }
}
